"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.auth = void 0;
var type = _interopRequireWildcard(require("./constants"));
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function (e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
const initialState = {
  init: false,
  isActive: false,
  user: null,
  authenticated: false,
  submissionAccess: {},
  formAccess: {},
  projectAccess: {},
  roles: {},
  is: {},
  error: ''
};
function mapProjectRolesToUserRoles(projectRoles, userRoles) {
  return Object.entries(projectRoles).reduce((result, _ref) => {
    let [name, role] = _ref;
    return {
      ...result,
      [name]: userRoles.includes(role._id)
    };
  }, {});
}
function getUserRoles(projectRoles) {
  return Object.keys(projectRoles).reduce((result, name) => ({
    ...result,
    [name]: name === 'anonymous'
  }), {});
}
const auth = () => function () {
  let state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : initialState;
  let action = arguments.length > 1 ? arguments[1] : undefined;
  switch (action.type) {
    case type.USER_REQUEST:
      return {
        ...state,
        init: true,
        submissionAccess: false,
        isActive: true
      };
    case type.USER_REQUEST_SUCCESS:
      return {
        ...state,
        isActive: false,
        user: action.user,
        authenticated: true,
        is: mapProjectRolesToUserRoles(state.roles, action.user.roles),
        error: ''
      };
    case type.USER_REQUEST_FAILURE:
      return {
        ...state,
        isActive: false,
        is: getUserRoles(state.roles),
        error: action.error
      };
    case type.USER_LOGOUT:
      return {
        ...state,
        user: null,
        isActive: false,
        authenticated: false,
        is: getUserRoles(state.roles),
        error: ''
      };
    case type.USER_SUBMISSION_ACCESS:
      return {
        ...state,
        submissionAccess: action.submissionAccess
      };
    case type.USER_FORM_ACCESS:
      return {
        ...state,
        formAccess: action.formAccess
      };
    case type.USER_PROJECT_ACCESS:
      return {
        ...state,
        projectAccess: action.projectAccess
      };
    case type.USER_ROLES:
      return {
        ...state,
        roles: action.roles
      };
    default:
      return state;
  }
};
exports.auth = auth;