"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.form = form;
var types = _interopRequireWildcard(require("./constants"));
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function (e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
function form(config) {
  const initialState = {
    id: '',
    isActive: false,
    lastUpdated: 0,
    form: {},
    url: '',
    error: ''
  };
  return function () {
    let state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : initialState;
    let action = arguments.length > 1 ? arguments[1] : undefined;
    // Only proceed for this form.
    if (action.name !== config.name) {
      return state;
    }
    switch (action.type) {
      case types.FORM_CLEAR_ERROR:
        return {
          ...state,
          error: ''
        };
      case types.FORM_REQUEST:
        return {
          ...state,
          isActive: true,
          id: action.id,
          form: {},
          url: action.url,
          error: ''
        };
      case types.FORM_SUCCESS:
        return {
          ...state,
          isActive: false,
          id: action.form._id,
          form: action.form,
          url: action.url || state.url,
          error: ''
        };
      case types.FORM_FAILURE:
        return {
          ...state,
          isActive: false,
          isInvalid: true,
          error: action.error
        };
      case types.FORM_SAVE:
        return {
          ...state,
          isActive: true
        };
      case types.FORM_RESET:
        return initialState;
      default:
        return state;
    }
  };
}