"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.resetForms = exports.indexForms = void 0;
var _lib = require("@arun-s-aot/formiojs/lib");
var _root = require("../root");
var types = _interopRequireWildcard(require("./constants"));
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function (e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
const resetForms = name => ({
  type: types.FORMS_RESET,
  name
});
exports.resetForms = resetForms;
const requestForms = (name, page, params) => ({
  type: types.FORMS_REQUEST,
  name,
  page,
  params
});
const receiveForms = (name, forms) => ({
  type: types.FORMS_SUCCESS,
  name,
  forms
});
const failForms = (name, error) => ({
  type: types.FORMS_FAILURE,
  name,
  error
});
const indexForms = function (name) {
  let page = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 1;
  let params = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
  let done = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : () => {};
  return (dispatch, getState) => {
    dispatch(requestForms(name, page, params));
    const {
      limit,
      query,
      select,
      sort
    } = (0, _root.selectRoot)(name, getState());
    const formio = new _lib.Formio(`${_lib.Formio.getProjectUrl()}/form`);
    const requestParams = {
      ...query,
      ...params
    };

    // Ten is the default so if set to 10, don't send.
    if (limit !== 10) {
      requestParams.limit = limit;
    } else {
      delete requestParams.limit;
    }
    if (page !== 1) {
      requestParams.skip = (page - 1) * limit;
    } else {
      delete requestParams.skip;
    }
    if (select) {
      requestParams.select = select;
    } else {
      delete requestParams.select;
    }
    if (sort) {
      requestParams.sort = sort;
    } else {
      delete requestParams.sort;
    }
    return formio.loadForms({
      params: requestParams
    }).then(result => {
      dispatch(receiveForms(name, result));
      done(null, result);
    }).catch(error => {
      dispatch(failForms(name, error));
      done(error);
    });
  };
};
exports.indexForms = indexForms;