"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.submissions = submissions;
var _pick2 = _interopRequireDefault(require("lodash/pick"));
var types = _interopRequireWildcard(require("./constants"));
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function (e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
function submissions(_ref) {
  let {
    name,
    limit = 10,
    query = {},
    select = '',
    sort = ''
  } = _ref;
  const initialState = {
    error: '',
    formId: '',
    isActive: false,
    limit,
    pagination: {
      numPages: 0,
      page: 1,
      total: 0
    },
    query,
    select,
    sort,
    submissions: []
  };
  return function () {
    let state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : initialState;
    let action = arguments.length > 1 ? arguments[1] : undefined;
    // Only proceed for this submissions.
    if (action.name !== name) {
      return state;
    }
    switch (action.type) {
      case types.SUBMISSIONS_RESET:
        return initialState;
      case types.SUBMISSIONS_REQUEST:
        return {
          ...state,
          ...(0, _pick2.default)(action.params, ['limit', 'query', 'select', 'sort']),
          error: '',
          formId: action.formId,
          isActive: true,
          pagination: {
            ...state.pagination,
            page: action.page
          },
          submissions: []
        };
      case types.SUBMISSIONS_SUCCESS:
        {
          const total = action.submissions.serverCount;
          return {
            ...state,
            isActive: false,
            pagination: {
              ...state.pagination,
              numPages: Math.ceil(total / state.limit),
              total
            },
            submissions: action.submissions
          };
        }
      case types.SUBMISSIONS_FAILURE:
        return {
          ...state,
          error: action.error,
          isActive: false
        };
      default:
        return state;
    }
  };
}